package com.alihealth.d2d.provtest.VO;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 描述: 药品生产信息 : 包含境内与境外的药品生产信息两个表，查询时注意字段转换
 */
@Data
public class DrugProductionInfoVO implements Serializable {

    private static final long serialVersionUID = 2214859259608999147L;

    /**
     * 药品生产日期
     */
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date scrq;

    /**
     * 药品有效期截止日期
     */
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date ypyxqjzrq;

    /**
     * 药品生产批号
     */
    private String ypscph;

    /**
     * 药品生产企业信用代码
     */
    private String tyshxydm;

    /**
     * 药品生产企业名称
     */
    private String scqymc;

    /**
     * 药品通用名称
     */
    private String yptymc;

    /**
     * 药品商用名称（中文）
     */
    private String ypspmc;

    /**
     * 国家药品标识码
     */
    private String gjypbsm;


    /**
     * 药品本位码
     */
    private String ypbwm;

    /**
     * 剂型
     */
    private String jx;

    /**
     * 制剂规格
     */
    private String zjgg;

    /**
     * 包装规格
     */
    private String bzgg;

    /**
     * 包装转换比
     */
    private Integer bzzhb;

    /**
     * 药品有效期
     */
    private Integer ypyxq;

    /**
     * 药品有效期单位
     */
    private String ypyxqdw;

    /**
     * 药品批准文号
     */
    private String yppzwh;

    /**
     * 药品批准文号有效期
     */
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date yppzwhyxq;
}
