package com.alihealth.d2d.provtest.service.handle.business;

import com.alihealth.d2d.provtest.domain.TransportTemperatureApplyInfo;
import com.alihealth.d2d.provtest.entity.EventBasic;
import com.alihealth.d2d.provtest.entity.EventBody;
import com.alihealth.d2d.provtest.entity.InstanceDetail;
import com.alihealth.d2d.provtest.entity.ItemDetail;
import com.alihealth.d2d.provtest.service.ITransportTemperatureApplyInfoService;
import com.alihealth.d2d.provtest.service.handle.AbstractEventDataHandler;
import com.alihealth.d2d.provtest.service.handle.EventSubType;
import com.baomidou.mybatisplus.extension.service.IService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.ParseException;
import java.text.SimpleDateFormat;

@Service
@EventSubType("2053")
public class SubType2053Handler extends AbstractEventDataHandler<TransportTemperatureApplyInfo> {

    @Autowired
    private ITransportTemperatureApplyInfoService service;

    @Override
    protected Class<TransportTemperatureApplyInfo> getEntityClass() {
        return TransportTemperatureApplyInfo.class;
    }

    @Override
    protected IService<TransportTemperatureApplyInfo> getService() {
        return service;
    }

    @Override
    protected TransportTemperatureApplyInfo convertToEntity(EventBody eventBody, ItemDetail item, InstanceDetail instance,String eventId) {
        EventBasic evtBasic = eventBody.getEvtBasic();
        //时间格式
        SimpleDateFormat formatterDatetime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        //日期格式
        SimpleDateFormat formatterDate = new SimpleDateFormat("yyyyMMdd");

        try {
            return TransportTemperatureApplyInfo.builder()
                    .eventId(eventId)
                    .recTime(formatterDatetime.parse(eventBody.getRecTime()))

                    .tyshxydm(evtBasic.getString("TYSHXYDM"))
                    .qymc(evtBasic.getString("QYMC"))
                    .fhdh(evtBasic.getString("FHDH"))
                    .wdxx(evtBasic.getString("WDXX"))
                    .ccsbbh(evtBasic.getString("CCSBBH"))
                    .ccsbmc(evtBasic.getString("CCSBMC"))
                    .ysqytyshxydm(evtBasic.getString("YSQYTYSHXYDM"))
                    .ysqyqymc(evtBasic.getString("YSQYQYMC"))

                    .build();
        } catch (ParseException e) {
            throw new RuntimeException(e);
        }
    }

    @Override
    public String getSubType() {
        return "2053";
    }

    @Override
    public void handleBase(String xml, String eventId) {

    }
}
